"use strict"
// базовый общий для всех
XHEBaseObject = require("../../xhe_base.js")

/////////////////////////////////////////// Plgn_XML ////////////////////////////////////////
class XHEXML extends XHEBaseObject
{
///////////////////////////////// SERVICE FUNCTIONS ////////////////////////////////////////////////
    // server initialization
    constructor(server, password = "") {
	    super(server, password, "Plgn_XML")
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////

    // отформатировать XML из строки
    format(content) {
        const params = ["content", content]
        return this.call_get("format", params)
    }

    // отформатировать XML из фаила
    format_from_file(xmlPath) {
        const params = ["xmlPath", xmlPath]
        return this.call_get("format_from_file", params)
    }

    // получить из строки XML все xpath всех узлов без индексов
    extract_xPaths(content) {
        const params = ["content", content]
        return this.call_get("extract_xPaths", params)
    }

    // получить из фаила XML все xpath всех узлов без индексов
    extract_xPaths_from_file(xmlPath) {
        const params = ["xmlPath", xmlPath]
        return this.call_get("extract_xPaths_from_file", params)
    }

    // выполнить xpath запрос для XML из строки
    get_by_xPath_single(content, xPath) {
        const params = ["content", content, "xPath", xPath]
        return this.call_get("get_by_xPath_single", params)
    }

    // выполнить xpath запрос для XML из фаила
    get_by_xPath_single_from_file(xmlPath, xPath) {
        const params = ["xmlPath", xmlPath, "xPath", xPath]
        return this.call_get("get_by_xPath_single_from_file", params)
    }

    // получить количество строк в XML из фаила
    get_lines_count_from_file(xmlPath) {
        const params = ["xmlPath", xmlPath]
        return this.call_get("get_lines_count_from_file", params)
    }

    // минимицировать XML из строки
    minify(content) {
        const params = ["content", content]
        return this.call_get("minify", params)
    }

    // минимицировать XML из фаила
    minify_from_file(xmlPath) {
        const params = ["xmlPath", xmlPath]
        return this.call_get("minify_from_file", params)
    }

    // валидация XML из строки
    validate(content, xsdScheme) {
        const params = ["content", content, "xsdScheme", xsdScheme]
        return this.call_get("validate", params)
    }

    // валидация XML из фаила
    validate_from_file(xmlPath, xsdScheme) {
        const params = ["xmlPath", xmlPath, "xsdScheme", xsdScheme]
        return this.call_get("validate_from_file", params)
    }
}
module.exports = XHEXML
