<?php
/////////////////////////////////////////// Plgn_XML //////////////////////////////////////
class XHEXML extends XHEBaseObject
{
//////////////////////////// SERVICE FUNCTIONS /////////////////////////////////////////////////////
    // server initialization
    private string $inner_number;

    function __construct(string $server, string $password="")
	{
		$this->server = $server;
		$this->password = $password;
		$this->prefix = "Plgn_XML";
	}
/////////////////////////////////////////////////////////////////////////////////////////////////////    
    
    // отформатировать XML из строки
    function format(string $content): string
    {
        $params = array( "content" => $content );
        return $this->call_get(__FUNCTION__, $params);
    }

    // отформатировать XML из фаила
    function format_from_file(string $xmlPath): string
    {
        $params = array( "xmlPath" => $xmlPath );
        return $this->call_get(__FUNCTION__, $params);
    }

    // получить из строки XML все xpath всех узлов без индексов
    function extract_xPaths(string $content): string
    {
        $params = array( "content" => $content );
        return $this->call_get(__FUNCTION__, $params);
    }

    // получить из фаила XML все xpath всех узлов без индексов
    function extract_xPaths_from_file(string $xmlPath): string
    {
        $params = array( "xmlPath" => $xmlPath );
        return $this->call_get(__FUNCTION__, $params);
    }

    // выполнить xpath запрос для XML из строки
    function get_by_xPath_single(string $content, string $xPath): string
    {
        $params = array( "content" => $content, "xPath" => $xPath );
        return $this->call_get(__FUNCTION__, $params);
    }

    // выполнить xpath запрос для XML из фаила
    function get_by_xPath_single_from_file(string $xmlPath, string $xPath): string
    {
        $params = array( "xmlPath" => $xmlPath, "xPath" => $xPath );
        return $this->call_get(__FUNCTION__, $params);
    }

    // получить количество строк в XML из фаила
    function get_lines_count_from_file(string $xmlPath): int
    {
        $params = array( "xmlPath" => $xmlPath );
        return $this->call_get(__FUNCTION__, $params);
    }

    // минимицировать XML из строки
    function minify(string $content): string
    {
        $params = array( "content" => $content );
        return $this->call_get(__FUNCTION__, $params);
    }

    // минимицировать XML из фаила
    function minify_from_file(string $xmlPath): string
    {
        $params = array( "xmlPath" => $xmlPath );
        return $this->call_get(__FUNCTION__, $params);
    }

    // валидация XML из строки
    function validate(string $content, string $xsdScheme): bool
    {
        $params = array( "content" => $content, "xsdScheme" => $xsdScheme );
        return $this->call_get(__FUNCTION__, $params);
    }

    // валидация XML из фаила
    function validate_from_file(string $xmlPath, string $xsdScheme): bool
    {
        $params = array( "xmlPath" => $xmlPath, "xsdScheme" => $xsdScheme );
        return $this->call_get(__FUNCTION__, $params);
    }
};

?>
