from Objects.xhe_base import *


# Plgn_XML
class XHEXML(XHEBaseObject):
    # server initialization
    def __init__(self, server: str, password: str=""):
        self.server = server
        self.password = password
        self.prefix = "Plgn_XML"


    # отформатировать XML из строки
    def format(self, content: str) -> str:
        params = {"content": content}
        return self.call_get("format", params)


    # отформатировать XML из фаила
    def format_from_file(self, xmlPath: str) -> str:
        params = {"xmlPath": xmlPath}
        return self.call_get("format_from_file", params)


    # получить из строки XML все xpath всех узлов без индексов
    def extract_xPaths(self, content: str) -> str:
        params = {"content": content}
        return self.call_get("extract_xPaths", params)


    # получить из фаила XML все xpath всех узлов без индексов
    def extract_xPaths_from_file(self, xmlPath: str) -> str:
        params = {"xmlPath": xmlPath}
        return self.call_get("extract_xPaths_from_file", params)


    # выполнить xpath запрос для XML из строки
    def get_by_xPath_single(self, content: str, xPath: str) -> str:
        params = {"content": content, "xPath": xPath}
        return self.call_get("get_by_xPath_single", params)


    # выполнить xpath запрос для XML из фаила
    def get_by_xPath_single_from_file(self, xmlPath: str, xPath: str) -> str:
        params = {"xmlPath": xmlPath, "xPath": xPath}
        return self.call_get("get_by_xPath_single_from_file", params)


    # получить количество строк в XML из фаила
    def get_lines_count_from_file(self, xmlPath: str) -> int:
        params = {"xmlPath": xmlPath}
        return self.call_get("get_lines_count_from_file", params)


    # минимицировать XML из строки
    def minify(self, content: str) -> str:
        params = {"content": content}
        return self.call_get("minify", params)


    # минимицировать XML из фаила
    def minify_from_file(self, xmlPath: str) -> str:
        params = {"xmlPath": xmlPath}
        return self.call_get("minify_from_file", params)


    # валидация XML из строки
    def validate(self, content: str, xsdScheme: str) -> bool:
        params = {"content": content, "xsdScheme": xsdScheme}
        return self.call_get("validate", params)


    # валидация XML из фаила
    def validate_from_file(self, xmlPath: str, xsdScheme: str) -> bool:
        params = {"xmlPath": xmlPath, "xsdScheme": xsdScheme}
        return self.call_get("validate_from_file", params)

